Subject: RE: bug: git config --global --unset doesn't unset configs in corner case

From: <[email-masked]>
Date: Fri, 10 May 2024 12:38:49 -0400

On Thursday, May 9, 2024 12:23 PM, Junio C Hamano wrote:
>Mike Hommey <[email-masked]> writes:
>
>> When both ~/.gitconfig and ~/.config/git/config exist, git will read
>> both. But when using `git config --global --unset`, it will only touch
>> the first one. So unsetting config items from ~/.config/git/config is
>> not possible from the command line when ~/.gitconfig exists.
>
>Interesting observation of an understandable behaviour.
>
>I think the original intent of limiting the writing to just one was to
avoid having both
>files in the first place.  When both do exist already, I am not sure what
the right
>behaviour on the write side should be.  We could special case "--unset-all"
and
>remove from both, but "--unset" is to remove just one, so when the reading
side
>reads from both, it becomes "which one to remove"?
>
>Comments from those who are more familiar with the "git config" are
certainly
>appreciated.

If both ~/.gitconfig and ~/.config/git/config both exist, a scope of
--global becomes ambiguous. The --file <file> option should disambiguate the
operation if just --unset is used. Otherwise, perhaps we should fail the
operation.

--Randall